unit AlignedPopupMenu;

{
  EasyMenus
  Copyright 2005 Murariu Alexandru
  muralexandru@yahoo.com
  All rights reserved.
  For conditions of distribution and use, see LICENSE.TXT.

}

interface

uses
  Windows, Messages, SysUtils, Classes, Menus, Controls;

type

  TAlignedPopup = (alpNone, alpTop, alpBottom, alpLeft, alpRight);

  TAlignedPopupMenu = class(TPopupMenu)
  private
  FAlignedPopup : TAlignedPopup;
  FALControl : TControl;
  procedure SETFALControl(Value : TControl);
  function GETFALControl : TControl;
    { Private declarations }
  protected
  procedure Notification(AComponent: TComponent;
  Operation: TOperation); override;
    { Protected declarations }
  public
  procedure Popup(X, Y: Integer); overload; override;
  procedure Popup; reintroduce; overload;
    { Public declarations }
  published
  property AlignedPopup : TAlignedPopup read FAlignedPopup write FAlignedPopup;
  property AlignToControl : TControl read GETFALControl write SETFALControl;
    { Published declarations }
  end;

implementation

procedure TAlignedPopupMenu.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  case Operation of
    opInsert:
      begin

      end;
    opRemove:
      begin
      if AlignToControl = AComponent then AlignToControl := nil;
      end;
  end;    
end;

procedure TAlignedPopupMenu.Popup;
begin
Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

procedure TAlignedPopupMenu.SETFALControl(Value : TControl);
begin
   FALControl := Value;
   if Value <> nil then Value.FreeNotification(Self);
end;

function TAlignedPopupMenu.GETFALControl : TControl;
begin
result := FALControl;
end;

procedure TAlignedPopupMenu.Popup(X, Y: Integer);
var P : TPoint;
begin
if not Assigned(FALControl) then
       begin
       inherited Popup(X,Y);
       Exit;
       end;
case Integer(FAlignedPopup) of
Integer(alpNone)   :  inherited Popup(X,Y);
Integer(alpTop)    :  begin
                      Alignment := paLeft;
                      P.X := 0;
                      P.Y := 0;
                      P := FALControl.ClientToScreen(P);
                      inherited Popup(P.X, P.Y);
                      end;
Integer(alpBottom) :  begin
                      Alignment := paLeft;
                      P.X := 0;
                      P.Y := FALControl.Height;
                      P := FALControl.ClientToScreen(P);
                      inherited Popup(P.X, P.Y);
                      end;
Integer(alpLeft)   :  begin
                      Alignment := paRight;
                      P.X := 0;
                      P.Y := 0;
                      P := FALControl.ClientToScreen(P);
                      inherited Popup(P.X, P.Y);
                      end;
Integer(alpRight)  :  begin
                      Alignment := paLeft;
                      P.X := FALControl.Width;
                      P.Y := 0;
                      P := FALControl.ClientToScreen(P);
                      inherited Popup(P.X, P.Y);
                      end;
end;
end;

end.
