unit EasyMenusAbout;

{
  EasyMenus
  Copyright 2005 Murariu Alexandru
  muralexandru@yahoo.com
  All rights reserved.
  For conditions of distribution and use, see LICENSE.TXT.

}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TEasyMenusAboutFrm = class(TForm)
    ImgAllComps: TImage;
    LabelTitle: TLabel;
    OKBtn: TButton;
    LabelCpr: TLabel;
    LabelMail: TLabel;
    Bevel1: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure LabelMailMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LabelMailMouseLeave(Sender: TObject);
    procedure LabelMailClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure ShowAbout;

implementation
uses EasyMenusVersion, ShellApi;

{$R *.dfm}

procedure ShowAbout;
var AbFrm : TEasyMenusAboutFrm;
begin
  AbFrm := nil;
  try
    AbFrm := TEasyMenusAboutFrm.Create(nil);
    AbFrm.ShowModal;
  finally
    AbFrm.Free;
  end;
end;

procedure TEasyMenusAboutFrm.FormCreate(Sender: TObject);
begin
  try
  ImgAllComps.Picture.Bitmap.LoadFromResourceName(HInstance, 'ALL_EASYMENUS_COMPONENTS');
  except
  end;
  LabelTitle.Caption := EasyMenusVersionText;
  LabelCpr.Caption := CprStr;
end;

procedure TEasyMenusAboutFrm.LabelMailMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
LabelMail.Font.Color := clBlue;
LabelMail.Font.Style := LabelMail.Font.Style + [fsUnderline];
end;

procedure TEasyMenusAboutFrm.LabelMailMouseLeave(Sender: TObject);
begin
LabelMail.Font.Color := clWindowText;
LabelMail.Font.Style := LabelMail.Font.Style - [fsUnderline];
end;

procedure TEasyMenusAboutFrm.LabelMailClick(Sender: TObject);
begin
LabelMail.Font.Color := clRed;
ShellExecute(0, 'open', PChar('mailto:' + LabelMail.Caption), '', '', SW_SHOWNORMAL);
end;

end.
