unit FavoritesEditorForm_unit;

{
  EasyMenus
  Copyright 2005 Murariu Alexandru
  muralexandru@yahoo.com
  All rights reserved.
  For conditions of distribution and use, see LICENSE.TXT.

}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Menus, AlignedPopupMenu, FileCtrl;

type
  TFavoritesEditorForm = class(TForm)
    ListView1: TListView;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    AlignedPopupMenu1: TAlignedPopupMenu;
    SelectFile1: TMenuItem;
    SelectDirectory1: TMenuItem;
    N1: TMenuItem;
    NewName1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure btnSelectFileClick(Sender: TObject);
    procedure SelectFile1Click(Sender: TObject);
    procedure SelectDirectory1Click(Sender: TObject);
    procedure NewName1Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
  procedure CheckEnabled;
    { Public declarations }
  end;

  resourcestring
  SSelFavorite = 'Select Favorite Item';

implementation

{$R *.dfm}

procedure TFavoritesEditorForm.CheckEnabled;
var E : boolean;
begin
E := (ListView1.Selected <> nil);
Button2.Enabled := E;
Button3.Enabled := E;
Button6.Enabled := E;
Button7.Enabled := E;
end;

procedure TFavoritesEditorForm.Button1Click(Sender: TObject);
var L : TListItem;
begin
L := ListView1.Items.Add;
L.EditCaption;
end;

procedure TFavoritesEditorForm.Button2Click(Sender: TObject);
begin
AlignedPopupMenu1.Popup;
end;

procedure TFavoritesEditorForm.Button3Click(Sender: TObject);
var L : TListItem;
    Index : integer;
begin
L := ListView1.Selected;
if L = nil then exit;
Index := L.Index - 1;
ListView1.Items.Delete(ListView1.Items.IndexOf(L));
if ListView1.Items.Count = 0 then Exit;
if Index < 0 then Index := 0;
ListView1.Items.Item[Index].Selected := True;
end;

procedure TFavoritesEditorForm.Button6Click(Sender: TObject);
var L,L2  :TListitem;
begin
try
L:=Listview1.selected;
L2:=Listview1.Items.Insert(L.Index-1);
L2.Assign(L);
L2.Selected:=True;
L2.MakeVisible(False);
L.Free;
except
end;
end;

procedure TFavoritesEditorForm.Button7Click(Sender: TObject);
var L,L2:TListItem;
begin
try
L:=Listview1.selected;
L2:=Listview1.Items.Insert(L.Index+2);
L2.Assign(L);
L2.Selected:=True;
L2.MakeVisible(False);
L.Free;
except
end;
end;

procedure TFavoritesEditorForm.FormShow(Sender: TObject);
begin
CheckEnabled;
Button8.Enabled := ((HelpType = htKeyword) and (HelpKeyword <> '')) or ((HelpType = htContext) and (HelpContext <> 0));
end;

procedure TFavoritesEditorForm.Button8Click(Sender: TObject);
begin
if ((HelpType = htKeyword) and (HelpKeyword <> '')) then Application.HelpKeyword(HelpKeyword);
if ((HelpType = htContext) and (HelpContext <> 0))  then Application.HelpContext(HelpContext);
end;

procedure TFavoritesEditorForm.ListView1Change(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
CheckEnabled;
end;

procedure TFavoritesEditorForm.btnSelectFileClick(Sender: TObject);
begin
AlignedPopupMenu1.Popup;
end;

procedure TFavoritesEditorForm.SelectFile1Click(Sender: TObject);
var S : string;
    L : TListItem;
begin
  L := ListView1.Selected;
  if L = nil then Exit;
  if FileExists(L.Caption) then S := L.Caption;
  if not PromptForFileName(S, '*.*', '', SSelFavorite) then exit;
  L.Caption := S;
end;

procedure TFavoritesEditorForm.SelectDirectory1Click(Sender: TObject);
var S : string;
    L : TListItem;
begin
  L := ListView1.Selected;
  if L = nil then Exit;
  if DirectoryExists(L.Caption) then S := L.Caption;
  if not SelectDirectory(SSelFavorite, '', S) then exit;
  L.Caption := S;
end;

procedure TFavoritesEditorForm.NewName1Click(Sender: TObject);
var L : TListItem;
begin
L := ListView1.Selected;
if L <> nil then L.EditCaption;
end;

procedure TFavoritesEditorForm.ListView1DblClick(Sender: TObject);
begin
if ListView1.Selected = nil then exit;
ListView1.Selected.EditCaption;
end;

end.
