unit ToolManagerEditor_SingleItem_unit;

{
  EasyMenus
  Copyright 2005 Murariu Alexandru
  muralexandru@yahoo.com
  All rights reserved.
  For conditions of distribution and use, see LICENSE.TXT.

}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, Buttons, ComCtrls;

type
  TToolManagerEditor_SingleItem = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    Button4: TButton;
    MacroList: TListView;
    Button5: TButton;
    Label5: TLabel;
    HelpBtn: TButton;
    MacrosBtn: TSpeedButton;
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure MacrosBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MacroListChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure Edit1Change(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
  MacrosVisible : boolean;
  procedure CheckVisible;
    { Public declarations }
  end;

implementation

{$R *.dfm}

procedure TToolManagerEditor_SingleItem.Button3Click(Sender: TObject);
begin
if FileExists(Edit2.Text) then OpenDialog1.FileName := Edit2.Text
                          else OpenDialog1.FileName := ''; 
if not OpenDialog1.Execute then Exit;
Edit2.Text := OpenDialog1.FileName;
if Edit1.Text = '' then Edit1.Text := ChangeFileExt(ExtractFileName(OpenDialog1.FileName),'');
if Edit3.Text = '' then Edit3.Text := ExtractFileDir(OpenDialog1.FileName);
end;

procedure TToolManagerEditor_SingleItem.Button4Click(Sender: TObject);
var S : String;
begin
if DirectoryExists(Edit3.Text) then S := Edit3.Text
                               else S := '';
if not SelectDirectory(Label3.caption,'',S) then Exit;
Edit3.Text := S;
end;

procedure TToolManagerEditor_SingleItem.MacrosBtnClick(Sender: TObject);
begin
MacrosVisible := not MacrosVisible;
CheckVisible;
end;

procedure TToolManagerEditor_SingleItem.CheckVisible;
begin
MacrosBtn.Visible := MacroList.Items.Count > 0;
MacroList.Visible := MacrosVisible;
Button5.Visible := MacrosVisible;
Label5.Visible := MacrosVisible;
if MacrosVisible then
   begin
   Self.ClientHeight := 240;
   try
   MacrosBtn.Glyph.LoadFromResourceName(HINSTANCE, 'MACRO_UP');
   except
   end;
   end
   else
   begin
   Self.ClientHeight := 145;
   try
   MacrosBtn.Glyph.LoadFromResourceName(HINSTANCE, 'MACRO_DOWN');
   except
   end;
   end;
end;

procedure TToolManagerEditor_SingleItem.FormCreate(Sender: TObject);
begin
MacrosVisible := False;
CheckVisible;
end;

procedure TToolManagerEditor_SingleItem.Button5Click(Sender: TObject);
var L : TListItem;
begin
L := MacroList.Selected;
if L = nil then Exit;
edit4.Text := Edit4.Text + L.Caption;
end;

procedure TToolManagerEditor_SingleItem.FormShow(Sender: TObject);
begin
CheckVisible;
HelpBtn.Enabled := ((HelpType = htKeyword) and (HelpKeyword <> '')) or ((HelpType = htContext) and (HelpContext <> 0));
end;

procedure TToolManagerEditor_SingleItem.MacroListChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
if Change <> ctState then Exit;
Button5.Enabled := MacroList.Selected <> nil;
end;

procedure TToolManagerEditor_SingleItem.Edit1Change(Sender: TObject);
begin
Button1.Enabled := (Edit1.Text <> '') and (Edit2.Text <> '');
end;

procedure TToolManagerEditor_SingleItem.HelpBtnClick(Sender: TObject);
begin
if ((HelpType = htKeyword) and (HelpKeyword <> '')) then Application.HelpKeyword(HelpKeyword);
if ((HelpType = htContext) and (HelpContext <> 0))  then Application.HelpContext(HelpContext);
end;

end.
